from twisted.spread import pb, jelly
import Singleton

        
class Transport:
    def __init__(self, number = "0", plant = "Standard", weight = "24000", weight_unit = "kg"):
      self.number = number
      self.plant  = plant
      self.weight = weight
      self.weight_unit = weight_unit


class Transports:
    __metaclass__ = Singleton.Singleton

    def __init__(self):
      self.transports = {}
      
    def getTransport(self,number):
      return self.transports[number]

    def addTransport(self,transport):
      self.transports[transport.number] = transport
      
    def getTransportList(self,fields):
      """ returns a tuple of a tuple of the given fields of all transports. got it? """
      transportList = []
      transportFields = []
      for t in self.transports.keys():
        for f in fields:
           transportFields.append(getattr(self.transports[t],f))
        transportList.append(transportFields)
        transportFields = []
      return transportList

    def updateTransport(self,transport):
      retval = False
      if isinstance(transport,Transport):
        self.transports[transport.number] = transport      
        retval = True
      return retval


class CopyTransport(Transport, pb.Copyable):
    pass

class ReceiverTransport(pb.RemoteCopy, Transport):
    pass


pb.setUnjellyableForClass(CopyTransport,ReceiverTransport)

