from twisted.cred.portal import IRealm
from twisted.cred import checkers 
from twisted.cred import portal 
from twisted.internet import reactor
from twisted.spread import pb, jelly

from threading import Timer

import Singleton
from Transports import Transports, Transport, CopyTransport, ReceiverTransport


class ClientRealm:
    def __init__(self):
        self.p = ClientPerspective()
    
    def requestAvatar(self, avatarId, mind, interface):
        print "avatarId=",avatarId
        self.p.loggedIn = 1
        self.p.avatarId = avatarId
        return pb.IPerspective, self.p, self.p.logout


class ClientPerspective(pb.Perspective):
    __implements__ = pb.IPerspective,

    def __init__(self):
        pass
    
    def perspective_getViewOnTransports(self):
        return ClientViewOnTransports()

    def logout(self):
        self.loggedOut = 1


class ClientViewOnTransports(pb.Viewable):
    __metaclass__ = Singleton.Singleton

    def __init__(self):
        self.transports = Transports()
        self.clients = {}
        
    def view_subscribe(self,perspective,callback):
        print "",perspective.avatarId," subscribed"
        self.clients[perspective.avatarId] = callback

    def view_unsubscribe(self,perspective):
        del self.clients[perspective.avatarId]

    def view_getTransport(self, perspective, number):
        return self.transports.getTransport(number)

    def view_getTransportList(self, perspective, fields = []):
        return self.transports.getTransportList(fields)

    def view_updateTransport(self, user, transport):
        if isinstance(transport,Transport) or isinstance(transport,ReceiverTransport):
          dmy = CopyTransport()
          for k in vars(transport):
            setattr(dmy, k, getattr(transport, k))
          transport = dmy
        if isinstance(transport,ReceiverTransport):
          #everything ok
          pass
        if isinstance(transport,CopyTransport):
          if self.transports.updateTransport(transport):
            print len(self.clients.keys())
            for client in self.clients.keys():
              print client
              try:
                print "calling remote updateTransport()", client, self.clients[client]
                self.clients[client].callRemote("updateTransport",transport)          
              except:
                print "Dead Reference", client, self.clients[client]
                del self.clients[client]          


tps = Transports()
tps.addTransport( CopyTransport(number="1",weight="12000") )
tps.addTransport( CopyTransport(number="2",weight="22000") )
tps.addTransport( CopyTransport(number="3",weight="12000") )
tps.addTransport( CopyTransport(number="4",weight="13000") )
tps.addTransport( CopyTransport(number="5",weight="14000") )
tps.addTransport( CopyTransport(number="6",weight="17000") )
    

checker = checkers.InMemoryUsernamePasswordDatabaseDontUse()
checker.addUser("bob","bob")
checker.addUser("nici","nici")

realm =  ClientRealm()
portal = portal.Portal(realm)
portal.registerChecker(checker)
server = pb.PBServerFactory(portal)

reactor.listenTCP(8080, server, interface="localhost")
print "running on ", 8080
reactor.run()
print "stopped"


